Package com.orchestranetworks.userservice.declaration

# Interface UserServiceExtensionDeclaration

public interface UserServiceExtensionDeclaration
Allows to extend an existing user service.

Only built-in services and services declared in the current module or data model can be extended.

A user service can be extended either in the context of a data model or in the context of a module.

Since:
  5.8.0

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `defineProperties(UserServicePropertiesDefinitionContext aContext)`
  Defines additional properties of the user service extension, in particular its label and description.
  `void`
  `extendWebComponent(WebComponentDeclarationContext aContext)`
  Defines the additional web component properties of the user service extension, and whether it can be available as a perspective action and/or a workflow user task.
  `ServiceKey`
  `getExtendedServiceKey()`
  Returns the identifier of the user service to be extended.
  `ServiceKey`
  `getServiceKey()`
  Returns the identifier of the user service extension.

- ## Method Details

  - ### getServiceKey

    ServiceKey getServiceKey()
    Returns the identifier of the user service extension.

    The returned `ServiceKey` must conform to the current declaration context; for example, if the service is being declared in the context of a module, its key must contain the module name.

    This method is invoked only once, when the user service extension is registered.

  - ### getExtendedServiceKey

    ServiceKey getExtendedServiceKey()
    Returns the identifier of the user service to be extended.

    This method is invoked only once, when the user service extension is registered.

  - ### defineProperties

    void defineProperties(UserServicePropertiesDefinitionContext aContext)
    Defines additional properties of the user service extension, in particular its label and description.

    This method is invoked only once, when the user service is registered.

  - ### extendWebComponent

    void extendWebComponent(WebComponentDeclarationContext aContext)
    Defines the additional web component properties of the user service extension, and whether it can be available as a perspective action and/or a workflow user task.

    This method is invoked only once, when the user service extension is registered.